/*******************************************************************
 * Copyright:2016-2021 www.corvin.cn ROSС
 * Description:ʹôڷʽȡͿIMUģϢ.
 * Author: corvin
 * History:
 *   20211122:init this file.
******************************************************************/

#include "../lib/imu_data.h"

#define  BYTE_CNT      88  //ÿδӴжȡֽ
#define  ACCE_CONST    0.000488281   //ڼٶȵĳ16.0/32768.0
#define  ANGULAR_CONST 0.061035156   //ڼٶȵĳ2000.0/32768.0
#define  ANGLE_CONST   0.005493164   //ڼŷǵĳ180.0/32768.0

static unsigned char r_buf[BYTE_CNT];  //һδӴжȡݴ洢
static int port_fd = -1; //ڴʱļ
static float acce[3], angular[3], angle[3], quater[4];
SerialPort serial;

using namespace std;

/******************************************************
 * Description:IMUģ鴮,봮ںż.
 *   open()ʧʱ,-1.
 *   :
 *   string:IMU豸Ĵڵַ;
 *****************************************************/
int openSerialPort(string imu_dev)
{
    int fd = 0;
    fd = serial.open(imu_dev.c_str(), 115200, 0, 8, 1);
   
    if (1 != fd)
    {
        return fd;
    }

    return fd;
}

/**************************************
 * Description:رմļ.
 *************************************/
void closeSerialPort(void)
{
    serial.close();;
}


/*****************************************************************
 * Description:IMUģĴз,һȽ,β
 *   Ϳ,ҪղŵĲ.ǹ
 *   0xFF 0xAA 0x69 0x88 0xB5,Ҳǹ̶0xFF 0xAA 0x00
 *   0x00 0x00.
 *****************************************************************/
int send_data(unsigned char* send_buffer, int length)
{
    int ret = -1;
    unsigned char unLockCmd[5] = { 0xFF, 0xAA, 0x69, 0x88, 0xB5 };
    unsigned char saveCmd[5] = { 0xFF, 0xAA, 0x00, 0x00, 0x00 };

    ret = serial.send(unLockCmd, sizeof(unLockCmd));
    if (ret != sizeof(unLockCmd))
    {
        cout << "Send IMU module unlock cmd error !" << endl;
        return -1;
    }
    Sleep(10);

#if 0 //ӡ͸IMUģ,ڵ
    printf("Send %d byte to IMU:", length);
    for (int i = 0; i < length; i++)
    {
        printf("0x%02x ", send_buffer[i]);
    }
    printf("\n");
#endif

    //Ϳ
    ret = serial.send(send_buffer, length * sizeof(unsigned char));
    if (ret != length)
    {
        cout << "Send IMU module control cmd error !" << endl;
        return -2;
    }

    //ͱ
    ret = serial.send(saveCmd, sizeof(saveCmd));
    if (ret != sizeof(saveCmd))
    {
        cout << "Send IMU module save cmd error !" << endl;
        return -3;
    }
    Sleep(100);
    return 0;
}

/********************************************************************
 * Description:yawǶȹ,Ҫͨڷ͵ʾ,
 *  zǶȹĹ̶:0xFF 0xAA 0x01 0x04 0x00;
 *******************************************************************/
int makeYawZero(void)
{
    int ret = 0;
    unsigned char yawZeroCmd[5] = { 0xFF, 0xAA, 0x01, 0x04, 0x00 };

    ret = send_data(yawZeroCmd, sizeof(yawZeroCmd));
    if (ret != 0) //ͨڷʧ
    {
        cout << endl <<"yawǹ0ʧܣ" << endl << endl;
        return -1;
    }
    cout << endl << "yawǹ0ɹ !" << endl << endl;

    return 0;
}

/******************************************************************
 * Description:IMUģIICַ,ͨʹʽIICַ,
 *   ĿΪ:0xFF 0xAA 0x1A 0x** 0x00,µIICַΪ4ֽ.
 *****************************************************************/
int updateIICAddr(std::string input)
{
    int ret = 0;
    stringstream num;
    int addr = 0;
    const char* iicAddr = NULL;
    unsigned char updateIICAddrCmd[5] = { 0xFF, 0xAA, 0x1A, 0x00, 0x00 };

    iicAddr = input.c_str();
    num << std::hex << iicAddr + 2 << std::endl;
    num >> addr;
    updateIICAddrCmd[3] = addr;

#if 0
    for (int i = 0; i < 5; i++)
    {
        printf("0x%02x ", updateIICAddrCmd[i]);
    }
    printf("\n\n");
#endif

    ret = send_data(updateIICAddrCmd, sizeof(updateIICAddrCmd));
    if (ret != 0)
    {
        cout << endl <<"IMUI2Cַʧ " << endl << endl;
        return -1;
    }
    cout << endl <<"IMUI2Cַɹ !" << endl << endl;

    return 0;
}

/********************************************************************
 * Description:ʾIMUģȡݡ
 *******************************************************************/
void show_imu_data()
{
    float yaw, pitch, roll;
    float degree2Rad = 3.1415926 / 180.0;
    float acc_factor = 9.806;
    while (true)
    {
        if (getImuData() < 0)
            break;
        if (kbhit())
            break;
        roll = getAngle(0) * degree2Rad;
        pitch = getAngle(1) * degree2Rad;
        yaw = getAngle(2) * degree2Rad;
        if (yaw >= 3.1415926)
            yaw -= 6.2831852;

        cout << endl;
        cout.setf(std::ios::right);
        cout << "roll:    " << setw(12) << roll << "  pitch:   " << setw(12) << pitch << "  yaw:     " << setw(12) << yaw << endl;
        cout << "q_x:     " << setw(12) << getQuat(1) << "  q_y:     " << setw(12) << getQuat(2) << "  q_z:     " << setw(12) << getQuat(3) << "  q_w: " << setw(12) << getQuat(0) << endl;
        cout << "a_v_x:   " << setw(12) << getAngular(0) * degree2Rad << "  a_v_y:   " << setw(12) << getAngular(1) * degree2Rad << "  a_v_z:   " << setw(12) << getAngular(2) * degree2Rad << endl;
        cout << "l_acc_x: " << setw(12) << -getAcc(0) * acc_factor << "  l_acc_y: " << setw(12) << -getAcc(1) * acc_factor << "  l_acc_z: " << setw(12) << -getAcc(2) * acc_factor << endl;

        Sleep(100);
    }
}

/**************************************************************
 * Description:ݴЭЧ,ﹲ4.
 *   ȡе44ֽ,4֡,ÿһ֡11ֽ.
 *   Чݰٶ(0x55 0x51),ٶ(0x55 0x52)
 *   Ƕ(0x55 0x53),Ԫ(0x55 0x59).
 *************************************************************/
void parse_serialData(unsigned char chr)
{
    static unsigned char chrBuf[BYTE_CNT];
    static unsigned char chrCnt = 0;  //¼ȡĵڼֽ

    signed short sData[4]; //save 8 ByteЧϢ
    unsigned char i = 0;   //forѭ
    unsigned char frameSum = 0;  //洢֡У

    chrBuf[chrCnt++] = chr; //浱ǰֽ,ֽڼ1

    //жǷȡһ֡11ֽ,û򷵻زн
    if (chrCnt < 11)
        return;

    //ȡһ֡,֡ǰʮֽڵУ,ۼӼɵõ
    for (i = 0; i < 10; i++)
    {
        frameSum += chrBuf[i];
    }

    //ҵ֡һֽ0x55,ͬʱжУǷȷ,һȷ,
    //Ҫƶʼֽ,ٶȡµֽڽж֡
    if ((chrBuf[0] != 0x55) || (frameSum != chrBuf[10]))
    {
        memcpy(&chrBuf[0], &chrBuf[1], 10); //Чǰƶ1ֽλ
        chrCnt--; //ֽڼ1,Ҫٶȡһֽڽ,ж֡
        return;
    }

#if 0 //ӡĴ֡ͷβ֡
    for (i = 0; i < 11; i++)
        printf("0x%02x ", chrBuf[i]);
    printf("\n");
#endif

    memcpy(&sData[0], &chrBuf[2], 8);
    switch (chrBuf[1])  //֡ͬн
    {
    case 0x51: //x,y,z ٶ
        acce[0] = ((short)(((short)chrBuf[3] << 8) | chrBuf[2])) * ACCE_CONST;
        acce[1] = ((short)(((short)chrBuf[5] << 8) | chrBuf[4])) * ACCE_CONST;
        acce[2] = ((short)(((short)chrBuf[7] << 8) | chrBuf[6])) * ACCE_CONST;
        break;
    case 0x52: //ٶ
        angular[0] = ((short)(((short)chrBuf[3] << 8) | chrBuf[2])) * ANGULAR_CONST;
        angular[1] = ((short)(((short)chrBuf[5] << 8) | chrBuf[4])) * ANGULAR_CONST;
        angular[2] = ((short)(((short)chrBuf[7] << 8) | chrBuf[6])) * ANGULAR_CONST;
        break;
    case 0x53: //ŷǶ, roll, pitch, yaw
        angle[0] = ((short)(((short)chrBuf[3] << 8) | chrBuf[2])) * ANGLE_CONST;
        angle[1] = ((short)(((short)chrBuf[5] << 8) | chrBuf[4])) * ANGLE_CONST;
        angle[2] = ((short)(((short)chrBuf[7] << 8) | chrBuf[6])) * ANGLE_CONST;
        break;
    case 0x59: //Ԫ
        quater[0] = ((short)(((short)chrBuf[3] << 8) | chrBuf[2])) / 32768.0;
        quater[1] = ((short)(((short)chrBuf[5] << 8) | chrBuf[4])) / 32768.0;
        quater[2] = ((short)(((short)chrBuf[7] << 8) | chrBuf[6])) / 32768.0;
        quater[3] = ((short)(((short)chrBuf[9] << 8) | chrBuf[8])) / 32768.0;
        //printf("%f %f %f %f\n", quater[0], quater[1], quater[2], quater[3]);
        break;
    default:
        cout << "parse imu data frame type error !" << endl;
        break;
    }
    chrCnt = 0;
}


/*****************************************************************
 * Description:ݴϢIMU,׼ͨ,
 *   :
 *   const char* path:IMU豸Ĺصַ;
 *   const int baud:IMUģĴͨŲ;
 ****************************************************************/
int initSerialPort(string imu_dev)
{
    port_fd = openSerialPort(imu_dev);
    if (port_fd != 1) //IMUģ鴮ʧ
    {
        return port_fd;
    }

    return port_fd;
}

/*****************************************
 * Description:õٶϢ,
 * Ϊ0,1,2ֱx,y,z
 * ٶϢ.
 *****************************************/
float getAcc(int flag)
{
    return acce[flag];
}

/******************************************
 * Description:õٶϢ,
 * Ϊ0,1,2,ֱx,y,zĽٶ
 *   Ϣ.
 *****************************************/
float getAngular(int flag)
{
    return angular[flag];
}

/********************************************
 * Description:ȡyaw,pitch,roll,0,
 * 1,2Էֱȡroll,pitch,yaw.
 *******************************************/
float getAngle(int flag)
{
    return angle[flag];
}

/********************************************
 * Description:0,1,2,3Էֱȡ
 * Ԫصq0,q1,q2,q3.Ӧros
 * imu_msg.orientation.w,x,y,z˳,
 * q0ǶӦw,1,2,3Ӧx,y,z.
 ********************************************/
float getQuat(int flag)
{
    return quater[flag];
}

/*************************************************************
 * Description:Ӵڶȡ,ȻЧݶ,
 *  һԴӴжȡ88ֽ,ȻҪЩֽн
 *  ȡ44ֽ,4֡,ÿһ֡11ֽ.
 *  Чݰٶ(0x55 0x51),ٶ(0x55 0x52)
 *  Ƕ(0x55 0x53),Ԫ(0x55 0x59).
 *************************************************************/
int getImuData(void)
{
    int data_len = 0;
    //洢ǰ,
    memset(r_buf, 0, sizeof(r_buf));
    //ʼӴжȡ,䱣浽r_buf
    data_len = serial.receive(r_buf, sizeof(r_buf));
    //data_len = read(port_fd, r_buf, sizeof(r_buf));
    if (data_len <= 0) //Ӵжȡʧ
    {
        cout << "read serial port data failed !" << endl;
        closeSerialPort();
        return -1;
    }

    //printf("recv data len:%d\n", data_len); //һԴӴжȡֽ
    for (int i = 0; i < data_len; i++) //ȡݽн
    {
        //printf("0x%02x ", r_buf[i]);
        parse_serialData(r_buf[i]);
    }
    //printf("\n\n");

    return 0;
}
